/*
 * @Author: zhoufei
 * @Date: 2022-04-22 15:00:32
 * @LastEditors: zhoufei
 * @LastEditTime: 2022-04-24 18:02:52
 * @FilePath: /utils/queue/mq.go
 * @Description: 消息队列interface
 *
 * Copyright (c) 2022 by zhoufei, All Rights Reserved.
 */
package queue

type Producer interface {
	SendMsg(topic string, msg []byte) (qMsg *QueueMsg, err error)
	SendStringMsg(topic string, msg string) (qMsg *QueueMsg, err error)
	ShutDown() error
}
type Consumer interface {
	RegisterConsumer(topic string, recevieFunc func(qMsg *QueueMsg)) (err error)
	ShutDown() error
}

type QueueMsg struct {
	Topic string                 `json:"topic"`
	Body  []byte                 `json:"body"`
	Info  map[string]interface{} `json:"info"`
}
